# TrimTools
TrimTools is an open source set of tools for managing the firmware on plastic box Trimble 4000 series GPS receivers.

## Features
* Fully Supported Receivers (Firmware read/write)
	* 4000SE (Maxwell)
	* 4000SSE
	* 4000Si
	* 4000SSi
	* 4000RS
	* 4000DS 
* Partially Supported Receivers (interactive ROM Monitor only)
	* 4000SE (Gauss)
	* 4000RL2
	* 4000DL2
	* 4400
	* 7400MSi
* Cross Platform
* Fast
* Interactive ROM monitor


## Command Line Tools
`cmd/loader` - replacement for Trimble's loader.exe

	Usage of loader:
	  -b int
	    	baud rate (default 38400)
	  -d string
	    	serial port device (default "/dev/tty.usbserial-AB0JS0VU")
	  -dummy
	    	dummy mode
	  -f string
	    	write firmware from file to receiver
	  -m	start interactive monitor
	  -p string
	    	parity (none, even, lsodd) (default "none")
	  -s string
	    	save firmware from receiver to file
	  -v	show version and exit
	  -x	enable debug messages

`cmd/convertx` - tool for converting to and from HP 64000 .X images as used by the loader tool.
	
	Usage convertx:
	  -b string
	    	binary image output filename
	  -i	print image metadata
	  -wnro
	    	attempt to patch WNRO bug
	  -x string
	    	.X output filename

## Known Issues
* Firmware upload/download for the Gauss 4000SE and the 4400 is either missing or not tested.
